<?php
/**
*
* @package acp
* @version $Id: acp_topiclist.php,v 1.0.1 2010-01-14 19:49:02 FladeX Exp $
* @copyright (c) 2009 FladeX
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_topiclist
{
	var $u_action;
	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$action = request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		if ($mode != 'index')
		{
			return;
		}

		$this->tpl_name = 'acp_topiclist';
		$this->page_title = 'ACP_TOPICLIST_SETTINGS';

		// Check additional permissions
		switch ($action)
		{
			case "generate":
				$forum = request_var('f', 0);
				$url = generate_board_url();
				$sql = 'SELECT forum_name
					FROM ' . FORUMS_TABLE . "
					WHERE forum_id=$forum";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				$html_content = '<li><b><a href="' . $url . '/viewforum.' . $phpEx . '?f=' . $forum . '">' . $row['forum_name'] . '</a></b></li>';
				$html_content .= '<ul>';
				$sql = 'SELECT topic_id, forum_id, topic_title, topic_type, topic_replies
					FROM ' . TOPICS_TABLE . "
					WHERE forum_id=$forum";
				$result = $db->sql_query($sql);
				while ($row = $db->sql_fetchrow($result))
				{
					$pages = $row['topic_replies'] / $config['posts_per_page'];
					$pages = (int) $pages;
					if ($pages <= 1)
					{
						$html_content .= '<li><a href="' . $url . '/viewtopic.' . $phpEx . '?f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . '">' . $row['topic_title'] . '</a></li>';
					}
					else
					{
						$html_content .= '<li><a href="' . $url . '/viewtopic.' . $phpEx . '?f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . '">' . $row['topic_title'] . '</a><br />[';
						for ($i=1; $i<=$pages; $i++)
						{
							$html_content .= '<a href="' . $url . '/viewtopic.' . $phpEx . '?f=' . $row['forum_id'] . '&amp;t=' . $row['topic_id'] . '&amp;start=' . $i * $config['posts_per_page'] . '">' . ($i+1) . '</a> ';
						}
						$html_content .= ']</li>';
					}
				}
				$db->sql_freeresult($result);
				$html_content .= '</ul>';

				$w = fopen('../topiclist/' . $forum . '.html', 'w');
				fwrite($w, $html_content);
				fclose($w);
			break;

			case "delete":
				$forum = request_var('f', 0);
				if (file_exists('../topiclist/' . $forum . '.html'))
				{
					unlink('../topiclist/' . $forum . '.html');
				}
			break;
		}

		$sql = 'SELECT *
			FROM ' . FORUMS_TABLE . "
			ORDER BY forum_id";
		$result = $db->sql_query($sql);

		if ($row = $db->sql_fetchrow($result))
		{
			do
			{
				$forum_type = $row['forum_type'];

				if ($row['forum_status'] == ITEM_LOCKED)
				{
					$folder_image = '<img src="images/icon_folder_lock.gif" alt="' . $user->lang['LOCKED'] . '" />';
				}
				else
				{
					switch ($forum_type)
					{
						case FORUM_LINK:
							$folder_image = '<img src="images/icon_folder_link.gif" alt="' . $user->lang['LINK'] . '" />';
						break;

						default:
							$folder_image = ($row['left_id'] + 1 != $row['right_id']) ? '<img src="images/icon_subfolder.gif" alt="' . $user->lang['SUBFORUM'] . '" />' : '<img src="images/icon_folder.gif" alt="' . $user->lang['FOLDER'] . '" />';
						break;
					}
				}

				$url = $this->u_action . "&amp;f={$row['forum_id']}";

				$template->assign_block_vars('forums', array(
					'FOLDER_IMAGE'		=> $folder_image,
					'FORUM_IMAGE'		=> ($row['forum_image']) ? '<img src="' . $phpbb_root_path . $row['forum_image'] . '" alt="" />' : '',
					'FORUM_IMAGE_SRC'	=> ($row['forum_image']) ? $phpbb_root_path . $row['forum_image'] : '',
					'FORUM_NAME'		=> $row['forum_name'],
					'FORUM_DESCRIPTION'	=> generate_text_for_display($row['forum_desc'], $row['forum_desc_uid'], $row['forum_desc_bitfield'], $row['forum_desc_options']),
					'FORUM_TOPICS'		=> $row['forum_topics'],
					'FORUM_POSTS'		=> $row['forum_posts'],

					'S_FORUM_LINK'		=> ($forum_type == FORUM_LINK) ? true : false,
					'S_FORUM_POST'		=> ($forum_type == FORUM_POST) ? true : false,

					'S_DELETE'			=> (file_exists('../topiclist/' . $row['forum_id'] . '.html')) ? true : false,

					'U_FORUM'			=> append_sid($this->u_action . '&amp;parent_id=' . $row['forum_id']),
					'U_GENERATE'		=> append_sid($url . '&amp;action=generate'),
					'U_DELETE'			=> append_sid($url . '&amp;action=delete')
				));
			}
			while ($row = $db->sql_fetchrow($result));
		}
		else if ($this->parent_id)
		{
			$row = $this->get_forum_info($this->parent_id);

			$url = $this->u_action . '&amp;parent_id=' . $this->parent_id . '&amp;f=' . $row['forum_id'];

			$template->assign_vars(array(
				'S_NO_FORUMS'		=> true,

				'U_EDIT'			=> append_sid($url . '&amp;action=edit'),
				'U_DELETE'			=> append_sid($url . '&amp;action=delete')
			));
		}
		$db->sql_freeresult($result);
	}
}

?>